unit WinFormLines;

interface

uses
  System.Drawing, System.Collections, System.ComponentModel,
  System.Windows.Forms, System.Data;

type
  TLinesForm = class(System.Windows.Forms.Form)
  {$REGION 'Designer Managed Code'}
  strict private
    /// <summary>
    /// Required designer variable.
    /// </summary>
    Components: System.ComponentModel.Container;
    MainMenu1: System.Windows.Forms.MainMenu;
    MenuItem1: System.Windows.Forms.MenuItem;
    MenuItem2: System.Windows.Forms.MenuItem;
    MenuItem3: System.Windows.Forms.MenuItem;
    /// <summary>
    /// Required method for Designer support - do not modify
    /// the contents of this method with the code editor.
    /// </summary>
    procedure InitializeComponent;
    procedure MenuItem2_Click(sender: System.Object; e: System.EventArgs);
    procedure MenuItem3_Click(sender: System.Object; e: System.EventArgs);
  {$ENDREGION}
  strict protected
    /// <summary>
    /// Clean up any resources being used.
    /// </summary>
    procedure Dispose(Disposing: Boolean); override;
  private
    { Private Declarations }
  public
    constructor Create;
  end;

  [assembly: RuntimeRequiredAttribute(TypeOf(TLinesForm))]

implementation

uses
  System.Drawing.Drawing2D;

{$AUTOBOX ON}

{$REGION 'Windows Form Designer generated code'}
/// <summary>
/// Required method for Designer support -- do not modify
/// the contents of this method with the code editor.
/// </summary>
procedure TLinesForm.InitializeComponent;
type
  TArrayOfSystem_Windows_Forms_MenuItem = array of System.Windows.Forms.MenuItem;
begin
  Self.MainMenu1 := System.Windows.Forms.MainMenu.Create;
  Self.MenuItem1 := System.Windows.Forms.MenuItem.Create;
  Self.MenuItem2 := System.Windows.Forms.MenuItem.Create;
  Self.MenuItem3 := System.Windows.Forms.MenuItem.Create;
  // 
  // MainMenu1
  // 
  Self.MainMenu1.MenuItems.AddRange(TArrayOfSystem_Windows_Forms_MenuItem.Create(Self.MenuItem1));
  // 
  // MenuItem1
  // 
  Self.MenuItem1.Index := 0;
  Self.MenuItem1.MenuItems.AddRange(TArrayOfSystem_Windows_Forms_MenuItem.Create(Self.MenuItem2, 
          Self.MenuItem3));
  Self.MenuItem1.Text := 'Draw';
  // 
  // MenuItem2
  // 
  Self.MenuItem2.Index := 0;
  Self.MenuItem2.Text := 'Lines';
  Include(Self.MenuItem2.Click, Self.MenuItem2_Click);
  // 
  // MenuItem3
  // 
  Self.MenuItem3.Index := 1;
  Self.MenuItem3.Text := 'Text';
  Include(Self.MenuItem3.Click, Self.MenuItem3_Click);
  // 
  // TLinesForm
  // 
  Self.AutoScaleBaseSize := System.Drawing.Size.Create(5, 13);
  Self.ClientSize := System.Drawing.Size.Create(384, 317);
  Self.Font := System.Drawing.Font.Create('Microsoft Sans Serif', 8.25, System.Drawing.FontStyle.Regular, 
      System.Drawing.GraphicsUnit.Point, (Byte(0)));
  Self.Menu := Self.MainMenu1;
  Self.Name := 'TLinesForm';
  Self.Text := 'WinFormLines';
end;
{$ENDREGION}

const
  nTimes = 5000;

procedure TLinesForm.Dispose(Disposing: Boolean);
begin
  if Disposing then
  begin
    if Components <> nil then
      Components.Dispose();
  end;
  inherited Dispose(Disposing);
end;

constructor TLinesForm.Create;
begin
  inherited Create;
  //
  // Required for Windows Form Designer support
  //
  InitializeComponent;
  //
  // TODO: Add any constructor code after InitializeComponent call
  //
end;

procedure TLinesForm.MenuItem3_Click(sender: System.Object; e: System.EventArgs);
var
  aBrush: System.Drawing.Brush;
  aFont: System.Drawing.Font;
  g: Graphics;
begin
  aBrush := LinearGradientBrush.Create (
    Self.ClientRectangle,
    Color.Aquamarine, Color.BlueViolet,
    LinearGradientMode.ForwardDiagonal);
  aFont := System.Drawing.Font.Create (
    'Arial Black', 25, GraphicsUnit.Millimeter);
  g := Self.CreateGraphics;
  try
    g.DrawString('Delphi for .NET', aFont,
      aBrush, 10, 10);
  finally
    aBrush.Free;
    aFont.Free;
    g.Dispose;
  end;
end;

procedure TLinesForm.MenuItem2_Click(sender: System.Object; e: System.EventArgs);
var
  I: Integer;
  aPen: Pen;
  g: Graphics;
begin
  aPen := Pen.Create (Color.Blue);
  g := Self.CreateGraphics;
  try
    for I := 1 to nTimes do
    begin
      Application.DoEvents;
      aPen.Color := Color.FromArgb (80,
        Random (255), Random (255), Random (255));
      g.DrawLine (aPen, Random (Width), Random (Height),
        Random (Width), Random (Height));
    end;
  finally
    aPen.Free;
    g.Dispose;
  end;
end;


end.
