unit TestNDemoClasses;
{

  Delphi NUnit Test Case
  ----------------------
  This unit contains a skeleton test case class generated by the Test Case Wizard.
  Modify the generated code to correctly setup and call the methods from the unit
  being tested.

}

interface

uses
  NUnit.Framework, NDemoClasses;

type
  // Test methods for class TMyTest
  [TestFixture]
  TestTMyTest = class
  strict private
    FMyTest: TMyTest;
  public
    [SetUp]
    procedure SetUp;
    [TearDown]
    procedure TearDown;
  published
    [Test]
    procedure TestText;
    [Test]
    procedure TestAdd;
    [Test]
    procedure TestDouble;
    [Test, ExpectedException(typeof(Exception))]
    procedure CheckException;
  end;

implementation

procedure TestTMyTest.SetUp;
begin
  FMyTest := TMyTest.Create;
end;

procedure TestTMyTest.TearDown;
begin
  FMyTest := nil;
end;

procedure TestTMyTest.TestText;
var
  ReturnValue: string;
begin
  fMyTest.Number := 10;
  ReturnValue := FMyTest.Text;
  // this test fails on purpose
  Assert.AreEqual(ReturnValue, '10', 'Error extracting text [fails on purpose]');
end;

procedure TestTMyTest.TestAdd;
begin
  FMyTest.Number := 10;
  FMyTest.Add(5);
  Assert.AreEqual(15, FMyTest.Number);
end;

procedure TestTMyTest.TestDouble;
begin
  FMyTest.Number := 20;
  FMyTest.Double;
  Assert.AreEqual(40, FMyTest.Number);
end;

procedure TestTMyTest.CheckException;
begin
  FMyTest.Add(-5); // raises exception
end;

end.

