unit AssemblyInfoForm;

interface

uses
  System.Drawing, System.Collections, System.ComponentModel,
  System.Windows.Forms, System.Data, System.Reflection;

type
  TWinForm = class(System.Windows.Forms.Form)
  {$REGION 'Designer Managed Code'}
  strict private
    /// <summary>
    /// Required designer variable.
    /// </summary>
    Components: System.ComponentModel.Container;
    TreeView1: System.Windows.Forms.TreeView;
    btnPopulate: System.Windows.Forms.Button;
    /// <summary>
    /// Required method for Designer support - do not modify
    /// the contents of this method with the code editor.
    /// </summary>
    procedure InitializeComponent;
    procedure btnPopulate_Click(sender: System.Object; e: System.EventArgs);
  {$ENDREGION}
  strict protected
    /// <summary>
    /// Clean up any resources being used.
    /// </summary>
    procedure Dispose(Disposing: Boolean); override;
  private
    { Private Declarations }
  public
    constructor Create;
  end;

  [assembly: RuntimeRequiredAttribute(TypeOf(TWinForm))]

implementation

{$AUTOBOX ON}

{$REGION 'Windows Form Designer generated code'}
/// <summary>
/// Required method for Designer support -- do not modify
/// the contents of this method with the code editor.
/// </summary>
procedure TWinForm.InitializeComponent;
begin
  Self.TreeView1 := System.Windows.Forms.TreeView.Create;
  Self.btnPopulate := System.Windows.Forms.Button.Create;
  Self.SuspendLayout;
  // 
  // TreeView1
  // 
  Self.TreeView1.Anchor := (System.Windows.Forms.AnchorStyles((((System.Windows.Forms.AnchorStyles.Top 
    or System.Windows.Forms.AnchorStyles.Bottom) or System.Windows.Forms.AnchorStyles.Left) 
    or System.Windows.Forms.AnchorStyles.Right)));
  Self.TreeView1.ImageIndex := -1;
  Self.TreeView1.Location := System.Drawing.Point.Create(16, 56);
  Self.TreeView1.Name := 'TreeView1';
  Self.TreeView1.SelectedImageIndex := -1;
  Self.TreeView1.Size := System.Drawing.Size.Create(552, 344);
  Self.TreeView1.TabIndex := 0;
  // 
  // btnPopulate
  // 
  Self.btnPopulate.Location := System.Drawing.Point.Create(16, 16);
  Self.btnPopulate.Name := 'btnPopulate';
  Self.btnPopulate.TabIndex := 1;
  Self.btnPopulate.Text := 'Populate';
  Include(Self.btnPopulate.Click, Self.btnPopulate_Click);
  // 
  // TWinForm
  // 
  Self.AutoScaleBaseSize := System.Drawing.Size.Create(5, 13);
  Self.ClientSize := System.Drawing.Size.Create(584, 414);
  Self.Controls.Add(Self.btnPopulate);
  Self.Controls.Add(Self.TreeView1);
  Self.Name := 'TWinForm';
  Self.Text := 'AssemblyInfo';
  Self.ResumeLayout(False);
end;
{$ENDREGION}

procedure TWinForm.Dispose(Disposing: Boolean);
begin
  if Disposing then
  begin
    if Components <> nil then
      Components.Dispose();
  end;
  inherited Dispose(Disposing);
end;

constructor TWinForm.Create;
begin
  inherited Create;
  //
  // Required for Windows Form Designer support
  //
  InitializeComponent;
  //
  // TODO: Add any constructor code after InitializeComponent call
  //
end;

procedure TWinForm.btnPopulate_Click(sender: System.Object; e: System.EventArgs);
var
  assemblyList: array of Assembly;
  assembly1: Assembly;
  assemblyNode, typeNode: TreeNode;
  typesList: array of System.Type;
  type1, type2: System.Type;
  event1: EventInfo;
  field1: FieldInfo;
  method1: MethodInfo;
begin
  TreeView1.BeginUpdate;
  try
    // get the list of assemblies of the application
    assemblyList := AppDomain.CurrentDomain.GetAssemblies;
    for assembly1 in assemblyList do
    begin
      assemblyNode := TreeNode.Create(assembly1.FullName, -1, -1);
      TreeView1.Nodes.Add(assemblyNode);
      typesList := assembly1.GetTypes;
      for type1 in typesList do
      begin
        typeNode := TreeNode.Create(type1.FullName, -1, -1);
        assemblyNode.Nodes.Add (typeNode);
        for field1 in type1.GetFields do
          typeNode.Nodes.Add (field1.ToString);
        for method1 in type1.GetMethods do
          typeNode.Nodes.Add (method1.ToString);
        for event1 in type1.GetEvents do
          typeNode.Nodes.Add (event1.ToString);
        for type2 in type1.GetNestedTypes do
          typeNode.Nodes.Add (type2.ToString);
      end;
    end;
  finally
    TreeView1.EndUpdate;
  end;
end;

end.
