unit DynaPackColF;

{$WARN UNIT_PLATFORM OFF}

interface

uses
  SysUtils, Windows, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, Buttons, TypInfo, System.Reflection;

type
  TForm1 = class(TForm)
    BtnChange: TButton;
    BtnTypes: TButton;
    cbWeb: TCheckBox;
    procedure BtnTypesClick(Sender: TObject);
    procedure BtnChangeClick(Sender: TObject);
  private
    aPack: Assembly;
    procedure LoadAssembly;
  end;

var
  Form1: TForm1;

implementation

uses
  Variants, System.Security.Policy;

{$R *.DFM}

procedure TForm1.BtnChangeClick(Sender: TObject);
var
  FormScroll: TForm;
  FormClass: TFormClass;
  aType: System.Type;
begin
  // load the assembly and get the type
  LoadAssembly;
  aType := aPack.GetType('PackScrollF.TFormScroll');
  FormClass := TFormClass(aType);
  FormScroll := FormClass.Create (Application);
  try
    // initialize the data
    SetPropValue (FormScroll, 'SelectedColor', Color);
    // show the form
    if FormScroll.ShowModal = mrOK then
      Color := TColor (GetPropValue (FormScroll, 'SelectedColor'));
  finally
    FormScroll.Free;
  end;
end;

procedure TForm1.BtnTypesClick(Sender: TObject);
var
  allTypes: array of System.Type;
  aType: System.Type;
begin
  LoadAssembly;
  allTypes := aPack.GetTypes;
  for aType in allTypes do
    ShowMessage (aType.ToString);
end;

procedure TForm1.LoadAssembly;
var
  ev1: Evidence;
begin
  if not Assigned (aPack) then
  begin
    if not cbWeb.Checked then
      aPack := Assembly.Load ('PackWithFormNet')
    else
    begin
      ev1 := Evidence.Create;
      ev1.AddHost (Url.Create('http://www.marcocantu.com'));
      aPack := Assembly.LoadFrom (
        'http://www.marcocantu.com/code/' +
        'md2005/test/PackWithFormNet.dll', ev1);
    end;
    // after loading disable option
    cbWeb.Enabled := False;
  end;
end;

end.

