unit MainForm;

interface

uses
  SpeechLib,
  System.Drawing, System.Collections, System.ComponentModel,
  System.Windows.Forms, System.Data;

type
  SAPIForm = class(System.Windows.Forms.Form)
  {$REGION 'Designer Managed Code'}
  strict private
    /// <summary>
    /// Required designer variable.
    /// </summary>
    Components: System.ComponentModel.Container;
    SpeakButton: System.Windows.Forms.Button;
    SpeechTextBox: System.Windows.Forms.TextBox;
    AVProgressBar: System.Windows.Forms.ProgressBar;
    /// <summary>
    /// Required method for Designer support - do not modify
    /// the contents of this method with the code editor.
    /// </summary>
    procedure InitializeComponent;
    procedure SAPIForm_Load(sender: System.Object; e: System.EventArgs);
    procedure SpeakButton_Click(sender: System.Object; e: System.EventArgs);
  {$ENDREGION}
  strict protected
    /// <summary>
    /// Clean up any resources being used.
    /// </summary>
    procedure Dispose(Disposing: Boolean); override;
  private
    { Private Declarations }
    SAPIVoice: SpVoice;
  public
    constructor Create;
    procedure AudioLevel(StreamNumber: Integer; StreamPosition: TObject;
      AudioLevel: Integer);
    procedure EndStream(StreamNumber: Integer; StreamPosition: TObject);
    procedure Word(StreamNumber: Integer; StreamPosition: TObject;
      CharacterPosition: Integer; Length: Integer);
  end;

  [assembly: RuntimeRequiredAttribute(TypeOf(SAPIForm))]

implementation

{$AUTOBOX ON}

{$REGION 'Windows Form Designer generated code'}
/// <summary>
/// Required method for Designer support -- do not modify
/// the contents of this method with the code editor.
/// </summary>
procedure SAPIForm.InitializeComponent;
begin
  Self.SpeakButton := System.Windows.Forms.Button.Create;
  Self.SpeechTextBox := System.Windows.Forms.TextBox.Create;
  Self.AVProgressBar := System.Windows.Forms.ProgressBar.Create;
  Self.SuspendLayout;
  // 
  // SpeakButton
  // 
  Self.SpeakButton.Anchor := System.Windows.Forms.AnchorStyles.Top;
  Self.SpeakButton.Location := System.Drawing.Point.Create(244, 8);
  Self.SpeakButton.Name := 'SpeakButton';
  Self.SpeakButton.TabIndex := 0;
  Self.SpeakButton.Text := '&Speak';
  Include(Self.SpeakButton.Click, Self.SpeakButton_Click);
  // 
  // SpeechTextBox
  // 
  Self.SpeechTextBox.Anchor := (System.Windows.Forms.AnchorStyles((((System.Windows.Forms.AnchorStyles.Top 
    or System.Windows.Forms.AnchorStyles.Bottom) or System.Windows.Forms.AnchorStyles.Left) 
    or System.Windows.Forms.AnchorStyles.Right)));
  Self.SpeechTextBox.HideSelection := False;
  Self.SpeechTextBox.Location := System.Drawing.Point.Create(8, 40);
  Self.SpeechTextBox.Multiline := True;
  Self.SpeechTextBox.Name := 'SpeechTextBox';
  Self.SpeechTextBox.ScrollBars := System.Windows.Forms.ScrollBars.Vertical;
  Self.SpeechTextBox.Size := System.Drawing.Size.Create(544, 88);
  Self.SpeechTextBox.TabIndex := 1;
  Self.SpeechTextBox.Text := '<VOLUME LEVEL="70">'#13#10'<EMPH>Hello</EMPH> ' +
  'Delphi developers!'#13#10'I can speak <PITCH MIDDLE="+20">high</PITCH> an' +
  'd <PITCH MIDDLE="-10">low</PITCH>.'#13#10'I can speak <RATE SPEED="+2">ve' +
  'ry quickly</RATE> and <RATE SPEED="-15">very slowly</RATE>.'#13#10'I can ' +
  'speak <VOLUME LEVEL="25">quietly</VOLUME> and <VOLUME LEVEL="100">loudly<' +
  '/VOLUME>.'#13#10'</VOLUME>';
  // 
  // AVProgressBar
  // 
  Self.AVProgressBar.Dock := System.Windows.Forms.DockStyle.Bottom;
  Self.AVProgressBar.Location := System.Drawing.Point.Create(0, 137);
  Self.AVProgressBar.Name := 'AVProgressBar';
  Self.AVProgressBar.Size := System.Drawing.Size.Create(562, 23);
  Self.AVProgressBar.TabIndex := 2;
  // 
  // SAPIForm
  // 
  Self.AutoScaleBaseSize := System.Drawing.Size.Create(5, 13);
  Self.ClientSize := System.Drawing.Size.Create(562, 160);
  Self.Controls.Add(Self.AVProgressBar);
  Self.Controls.Add(Self.SpeechTextBox);
  Self.Controls.Add(Self.SpeakButton);
  Self.FormBorderStyle := System.Windows.Forms.FormBorderStyle.FixedSingle;
  Self.Name := 'SAPIForm';
  Self.Text := 'SAPI Example';
  Include(Self.Load, Self.SAPIForm_Load);
  Self.ResumeLayout(False);
end;
{$ENDREGION}

procedure SAPIForm.Dispose(Disposing: Boolean);
begin
  if Disposing then
  begin
    if Components <> nil then
      Components.Dispose();
  end;
  inherited Dispose(Disposing);
end;

constructor SAPIForm.Create;
begin
  inherited Create;
  //
  // Required for Windows Form Designer support
  //
  InitializeComponent;
  //
  // TODO: Add any constructor code after InitializeComponent call
  //
end;

procedure SAPIForm.SpeakButton_Click(sender: System.Object; e: System.EventArgs);
begin
  SAPIVoice.Speak(SpeechTextBox.Text, SpeechVoiceSpeakFlags.SVSFlagsAsync)
end;

procedure SAPIForm.SAPIForm_Load(sender: System.Object; e: System.EventArgs);
begin
  SAPIVoice := SpVoiceClass.Create;
  //Hook up the three event handler methods
  Include(SAPIVoice.Word, Word);
  Include(SAPIVoice.EndStream, EndStream);
  Include(SAPIVoice.AudioLevel, AudioLevel);
  SAPIVoice.EventInterests :=
    SpeechVoiceEvents(
      Ord(SpeechVoiceEvents.SVEWordBoundary) or
      Ord(SpeechVoiceEvents.SVEEndInputStream) or
      Ord(SpeechVoiceEvents.SVEAudioLevel))
end;

procedure SAPIForm.Word(StreamNumber: Integer; StreamPosition: TObject;
  CharacterPosition, Length: Integer);
begin
  SpeechTextBox.SelectionStart := CharacterPosition;
  SpeechTextBox.SelectionLength := Length //highlight word
end;

procedure SAPIForm.EndStream(StreamNumber: Integer; StreamPosition: TObject);
begin
  //Reset VU meter
  AVProgressBar.Value := 0;
  //Highlight word being spoken in the text box
  SpeechTextBox.SelectionLength := 0;
  SpeechTextBox.SelectionStart := Length(speechTextBox.Text)
end;

procedure SAPIForm.AudioLevel(StreamNumber: Integer; StreamPosition: TObject;
  AudioLevel: Integer);
begin
  AVProgressBar.Value := AudioLevel
end;

end.
