﻿unit VLITestMain;

interface

{$WARN UNIT_PLATFORM OFF}
uses
  Win32DLLInterface,
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Borland.Vcl.ComCtrls, Borland.Vcl.StdCtrls, System.ComponentModel;

type
  TfrmMain = class(TForm)
    edtVal1: TEdit;
    edtVal2: TEdit;
    btnMin: TButton;
    UpDown1: TUpDown;
    UpDown2: TUpDown;
    btnANSI: TButton;
    btnUnicode: TButton;
    btnUserName: TButton;
    procedure btnUserNameClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure btnUnicodeClick(Sender: TObject);
    procedure btnANSIClick(Sender: TObject);
    procedure btnMinClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    DLLStuff: IWin32DLL;
  end;

var
  frmMain: TfrmMain;

implementation

uses
  System.Diagnostics, System.Text,
  Borland.Vcl.Win32;

{$R *.nfm}

procedure TfrmMain.btnMinClick(Sender: TObject);
var
  Val1, Val2, MinVal: Integer;
begin
  Val1 := StrToInt(edtVal1.Text);
  Val2 := StrToInt(edtVal2.Text);
  MinVal := DLLStuff.Min(Val1, Val2);
  DLLStuff.ShowMsgA(Format('Lower value of %d and %d is %d', [Val1, Val2, MinVal]),
    'Information')
end;

procedure TfrmMain.btnANSIClick(Sender: TObject);
begin
  DLLStuff.ShowMsgA('This is an ANSI message', 'ANSI')
end;

procedure TfrmMain.btnUnicodeClick(Sender: TObject);
begin
  //Believe it or not, there are various Unicode characters
  //embedded in the first parameter.
  //You can prove this by turning it into a call to ShowMsgA
  DLLStuff.ShowMsgW('тhіѕ іѕ а Unicode message', 'Unicode')
end;

procedure TfrmMain.FormCreate(Sender: TObject);
begin
  if not Supports(Win32DLL, TypeOf(IWin32DLL), DLLStuff) then
  begin
    ShowMessage('Unmanaged DLL not found');
    Application.ShowMainForm := False;
    Application.Terminate
  end
end;

procedure TfrmMain.btnUserNameClick(Sender: TObject);
var
  UserName: StringBuilder;
  UserNameLen: Cardinal;
begin
  UserName := StringBuilder.Create(30);
  UserNameLen := UserName.Capacity;
  if DLLStuff.GetUser(UserName, UserNameLen) = 0 then
    DLLStuff.ShowMsgA(UserName.ToString, 'User Name');
end;

end.
