unit ReadDataFormOdbc;

interface

uses
  System.Drawing, System.Collections, System.ComponentModel,
  System.Windows.Forms, System.Data, System.Data.Odbc;

type
  TReadDataWinForm = class(System.Windows.Forms.Form)
  {$REGION 'Designer Managed Code'}
  strict private
    /// <summary>
    /// Required designer variable.
    /// </summary>
    Components: System.ComponentModel.Container;
    lbCompanies: System.Windows.Forms.ListBox;
    btnGetData: System.Windows.Forms.Button;
    btnCount: System.Windows.Forms.Button;
    OdbcConnection1: System.Data.Odbc.OdbcConnection;
    OdbcCommand1: System.Data.Odbc.OdbcCommand;
    btnIDataReader: System.Windows.Forms.Button;

    /// <summary>
    /// Required method for Designer support - do not modify
    /// the contents of this method with the code editor.
    /// </summary>
    procedure InitializeComponent;
    procedure btnGetData_Click(sender: System.Object; e: System.EventArgs);
    procedure btnCount_Click(sender: System.Object; e: System.EventArgs);
    procedure btnIDataReader_Click(sender: System.Object; e: System.EventArgs);
  {$ENDREGION}
  strict protected
    /// <summary>
    /// Clean up any resources being used.
    /// </summary>
    procedure Dispose(Disposing: Boolean); override;
  private
    { Private Declarations }
  public
    procedure ReadData (Connection: IDbConnection; Command: IDbCommand);
    constructor Create;
  end;

  [assembly: RuntimeRequiredAttribute(TypeOf(TReadDataWinForm))]

implementation

{$AUTOBOX ON}

{$REGION 'Windows Form Designer generated code'}
/// <summary>
/// Required method for Designer support -- do not modify
/// the contents of this method with the code editor.
/// </summary>
procedure TReadDataWinForm.InitializeComponent;
begin
  Self.lbCompanies := System.Windows.Forms.ListBox.Create;
  Self.btnGetData := System.Windows.Forms.Button.Create;
  Self.btnCount := System.Windows.Forms.Button.Create;
  Self.OdbcConnection1 := System.Data.Odbc.OdbcConnection.Create;
  Self.OdbcCommand1 := System.Data.Odbc.OdbcCommand.Create;
  Self.btnIDataReader := System.Windows.Forms.Button.Create;
  Self.SuspendLayout;
  // 
  // lbCompanies
  // 
  Self.lbCompanies.Anchor := (System.Windows.Forms.AnchorStyles((((System.Windows.Forms.AnchorStyles.Top 
    or System.Windows.Forms.AnchorStyles.Bottom) or System.Windows.Forms.AnchorStyles.Left) 
    or System.Windows.Forms.AnchorStyles.Right)));
  Self.lbCompanies.Location := System.Drawing.Point.Create(8, 40);
  Self.lbCompanies.Name := 'lbCompanies';
  Self.lbCompanies.Size := System.Drawing.Size.Create(328, 277);
  Self.lbCompanies.TabIndex := 0;
  // 
  // btnGetData
  // 
  Self.btnGetData.Location := System.Drawing.Point.Create(11, 9);
  Self.btnGetData.Name := 'btnGetData';
  Self.btnGetData.TabIndex := 1;
  Self.btnGetData.Text := 'GetData';
  Include(Self.btnGetData.Click, Self.btnGetData_Click);
  // 
  // btnCount
  // 
  Self.btnCount.Location := System.Drawing.Point.Create(96, 8);
  Self.btnCount.Name := 'btnCount';
  Self.btnCount.TabIndex := 2;
  Self.btnCount.Text := 'Count';
  Include(Self.btnCount.Click, Self.btnCount_Click);
  // 
  // OdbcConnection1
  // 
  Self.OdbcConnection1.ConnectionString := 'SafeTransactions=0;MaxScanRows=8' +
  ';DefaultDir=C:\Program Files\Common Files\Borland Shared\Data;Threads=3;D' +
  'riverId=25;DBQ=C:\Program Files\Common Files\Borland Shared\Data\dbdemos.' +
  'mdb;UserCommitSync=Yes;FIL=MS Access;PageTimeout=5;Driver={Microsoft Acce' +
  'ss Driver (*.mdb)};MaxBufferSize=2048;UID=admin;FILEDSN=D:\md2005code\16\' +
  'AdoNetReadDataOdbc\OdbcDataSource.dsn';
  // 
  // OdbcCommand1
  // 
  Self.OdbcCommand1.Connection := Self.OdbcConnection1;
  // 
  // btnIDataReader
  // 
  Self.btnIDataReader.Location := System.Drawing.Point.Create(248, 8);
  Self.btnIDataReader.Name := 'btnIDataReader';
  Self.btnIDataReader.Size := System.Drawing.Size.Create(88, 23);
  Self.btnIDataReader.TabIndex := 3;
  Self.btnIDataReader.Text := 'IDataReader';
  Include(Self.btnIDataReader.Click, Self.btnIDataReader_Click);
  // 
  // TReadDataWinForm
  // 
  Self.AutoScaleBaseSize := System.Drawing.Size.Create(5, 13);
  Self.ClientSize := System.Drawing.Size.Create(344, 326);
  Self.Controls.Add(Self.btnIDataReader);
  Self.Controls.Add(Self.btnCount);
  Self.Controls.Add(Self.btnGetData);
  Self.Controls.Add(Self.lbCompanies);
  Self.Name := 'TReadDataWinForm';
  Self.Text := 'AdoNetReadDataOdbc';
  Self.ResumeLayout(False);
end;
{$ENDREGION}

procedure TReadDataWinForm.Dispose(Disposing: Boolean);
begin
  if Disposing then
  begin
    if Components <> nil then
      Components.Dispose();
  end;
  inherited Dispose(Disposing);
end;

constructor TReadDataWinForm.Create;
begin
  inherited Create;
  //
  // Required for Windows Form Designer support
  //
  InitializeComponent;
  //
  // TODO: Add any constructor code after InitializeComponent call
  //
end;

procedure TReadDataWinForm.btnIDataReader_Click(sender: System.Object; e: System.EventArgs);
begin
  ReadData (OdbcConnection1, OdbcCommand1);
end;

procedure TReadDataWinForm.btnCount_Click(sender: System.Object; e: System.EventArgs);
var
  ObjResult: System.Object;
begin
  if OdbcConnection1.State = ConnectionState.Closed then
    OdbcConnection1.Open;
  OdbcCommand1.CommandText := 'select count(*) from customer';
  ObjResult := OdbcCommand1.ExecuteScalar;
  MessageBox.Show(ObjResult.ToString, 'Customer count');
end;

procedure TReadDataWinForm.btnGetData_Click(sender: System.Object; e: System.EventArgs);
var
  Reader: OdbcDataReader;
begin
  if OdbcConnection1.State = ConnectionState.Closed then
    OdbcConnection1.Open;
  OdbcCommand1.CommandText := 'select * from customer';
  Reader := OdbcCommand1.ExecuteReader;
  try
    while Reader.Read do
     lbCompanies.items.Add (Reader.Item ['Company']);
  finally
    Reader.Close;
  end;
end;

procedure TReadDataWinForm.ReadData(
  Connection: IDbConnection; Command: IDbCommand);
var
  Reader: IDataReader;
begin
  if Connection.State = ConnectionState.Closed then
    Connection.Open;
  Command.CommandText := 'select * from customer';
  Reader := Command.ExecuteReader;
  try
    while Reader.Read do
      lbCompanies.items.Add (Reader.Item ['Company']);
  finally
    Reader.Close;
  end;
end;

end.
