
unit WebForm1;

interface

uses
  System.Collections, System.ComponentModel,
  System.Data, System.Drawing, System.Web, System.Web.SessionState,
  System.Web.UI, System.Web.UI.WebControls, System.Web.UI.HtmlControls;

type
  TWebForm1 = class(System.Web.UI.Page)
  {$REGION 'Designer Managed Code'}
  strict private
    procedure InitializeComponent;
    procedure btnGetInfo_Click(sender: System.Object; e: System.EventArgs);
    procedure btnGetMore_Click(sender: System.Object; e: System.EventArgs);
    procedure btnStoreMore_Click(sender: System.Object; e: System.EventArgs);
    procedure btnResize_Click(sender: System.Object; e: System.EventArgs);
  {$ENDREGION}
  strict private
    procedure Page_Load(sender: System.Object; e: System.EventArgs);
  strict protected
    Panel1: System.Web.UI.WebControls.Panel;
    Panel2: System.Web.UI.WebControls.Panel;
    TextBoxOne: System.Web.UI.WebControls.TextBox;
    TextBoxTwo: System.Web.UI.WebControls.TextBox;
    TextBoxThree: System.Web.UI.WebControls.TextBox;
    TextBoxFour: System.Web.UI.WebControls.TextBox;
    Label1: System.Web.UI.WebControls.Label;
    Label2: System.Web.UI.WebControls.Label;
    Label3: System.Web.UI.WebControls.Label;
    Label4: System.Web.UI.WebControls.Label;
    btnGetInfo: System.Web.UI.WebControls.Button;
    LabelOutput: System.Web.UI.WebControls.Label;
    btnStoreMore: System.Web.UI.WebControls.Button;
    btnGetMore: System.Web.UI.WebControls.Button;
    btnResize: System.Web.UI.WebControls.Button;
    procedure OnInit(e: EventArgs); override;
  private
    { Private Declarations }
  public
    { Public Declarations }
  end;

implementation

uses
  System.Text;

{$REGION 'Designer Managed Code'}
/// <summary>
/// Required method for Designer support -- do not modify
/// the contents of this method with the code editor.
/// </summary>
procedure TWebForm1.InitializeComponent;
begin
  Include(Self.btnStoreMore.Click, Self.btnStoreMore_Click);
  Include(Self.btnGetMore.Click, Self.btnGetMore_Click);
  Include(Self.btnGetInfo.Click, Self.btnGetInfo_Click);
  Include(Self.btnResize.Click, Self.btnResize_Click);
  Include(Self.Load, Self.Page_Load);
end;
{$ENDREGION}

procedure TWebForm1.Page_Load(sender: System.Object; e: System.EventArgs);
begin
  // TODO: Put user code to initialize the page here
  TextBoxFour.EnableViewState := False;
end;

procedure TWebForm1.OnInit(e: EventArgs);
begin
  //
  // Required for Designer support
  //
  InitializeComponent;
  inherited OnInit(e);
end;

procedure TWebForm1.btnResize_Click(sender: System.Object; e: System.EventArgs);
begin
  TextBoxOne.Width := 250;
  TextBoxTwo.Width := 250;
  TextBoxThree.Width := 250;
  TextBoxFour.Width := 250;
end;

procedure TWebForm1.btnGetMore_Click(sender: System.Object; e: System.EventArgs);
begin
  LabelOutput.Text := TextBoxOne.ViewState['More'].ToString;
end;

procedure TWebForm1.btnStoreMore_Click(sender: System.Object; e: System.EventArgs);
begin
  TextBoxOne.ViewState['More'] := TextBoxTwo.Text;
end;

procedure TWebForm1.btnGetInfo_Click(sender: System.Object; e: System.EventArgs);
var
  strOutput: StringBuilder;
  Ctrl: Control;
  key: string;
begin
  strOutput := StringBuilder.Create;
  strOutput.Append('Panel Child Controls Count: ');
  strOutput.Append(Panel1.Controls.Count);
  strOutput.Append('<br>');
  for Ctrl in Panel1.Controls do
  begin
    strOutput.Append(Ctrl.ToString); // long class name
    strOutput.Append(': ');
    strOutput.Append(Ctrl.ID);
    strOutput.Append('<br>');
  end;

  strOutput.Append('<br>');
  strOutput.Append('TextBoxOne.ViewState Count: ');
  strOutput.Append(TextBoxOne.ViewState.Count);
  strOutput.Append('<br>');
  for key in TextBoxOne.ViewState.Keys do
  begin
    strOutput.Append(key + ': ');
    strOutput.Append(TextBoxOne.ViewState.Item[key]);
    strOutput.Append('<br>');
  end;

  LabelOutput.Text := strOutput.ToString;
end;

end.
